﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WG_RefreshGridAndRestoreCollapsedRows
{
    public partial class Form1 : Form
    {
        List<string> expandedRows = new List<string>();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataSet ds = new DataSet();
            DataTable t1 = ds.Tables.Add("table1");
            t1.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t1.Columns.Add("Name", typeof(string));
            t1.Columns.Add("Quantity", typeof(int));
            t1.Columns.Add("Price", typeof(double));
            t1.Columns.Add("Date", typeof(DateTime));

            ds.Tables["table1"].Rows.Add(new Object[] { null, "Beverage", 50, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Appliances", 5, 90, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "FastFood", 20, 32, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Furniture", 12, 79, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Meat", 40, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Fruits", 25, 12, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Vegetables", 30, 13, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Cars", 13, 200, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Tools", 60, 15.3, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Estate", 5, 3000, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Motorcycles", 10, 320, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Clothes", 40, 69, new DateTime(2009, 02, 28) });

            ultraGrid1.DataSource = ds;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].SortedColumns.Add("id", false, true);
            e.Layout.Rows[4].Expanded = true;
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            // I can't get the rows to collapse by refreshing the grid.
            ultraGrid1.Rows.Refresh(RefreshRow.ReloadData, true);

            ultraGrid1.Refresh();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string filename = @"..\..\layout.xml";

            ultraGrid1.DisplayLayout.SaveAsXml(filename);
            ultraGrid1.DisplayLayout.LoadFromXml(filename);
        }

        private void ultraGrid1_AfterRowCollapsed(object sender, RowEventArgs e)
        {
            var groupByRow = e.Row as UltraGridGroupByRow;
            if (groupByRow != null && expandedRows.Contains(groupByRow.Value.ToString()))
            {
                expandedRows.Remove(groupByRow.Value.ToString());
            }
        }

        private void ultraGrid1_AfterRowExpanded(object sender, RowEventArgs e)
        {
            var groupByRow = e.Row as UltraGridGroupByRow;
            if (groupByRow != null 
                && expandedRows.Contains(groupByRow.Value.ToString()) == false)
            {
                expandedRows.Add(groupByRow.Value.ToString());
            }
        }

        private void ultraGrid1_InitializeGroupByRow(object sender, InitializeGroupByRowEventArgs e)
        {
            if (e.ReInitialize == false && expandedRows.Contains(e.Row.Value.ToString()))
            {
                e.Row.Expanded = true;
            }
        }


    }
}
